/* -------------------------------------------------------------------------- *
 * file:         buildzengin.c                                                *
 * purpose:      use a web form to build a zengin file from scratch           *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <cgic.h>
#include "zengingen.h"

int cgiMain() {
  struct tm mytime;
  time_t ts;
  char valuedatestr[5];

  if (cgiFormString("zfilename", zfilename, sizeof(zfilename)) == cgiFormSuccess) {
    snprintf(title, sizeof(title), "%s %s", "Edit Zengin File", zfilename);
    if(cgiFormString("zengindata", zengin_b64str, sizeof(zengin_b64str)) != cgiFormSuccess)
      int_error("Error Edit Zengin File: Cannot get file data");
  }
  else {
    if(cgiFormString("zengindata", zengin_b64str, sizeof(zengin_b64str)) == cgiFormSuccess)
      snprintf(title, sizeof(title), "%s", "Build a New Zengin File from Template");
    else {
      snprintf(title, sizeof(title), "%s", "Build a New Zengin File");
    }
    /* get the time */
    ts = time(NULL);
    mytime = *localtime(&ts);
    /* convert the timestamp into a human readable string */
    strftime(valuedatestr, sizeof(valuedatestr), "%m%d", &mytime);
  }
/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/

   pagehead(title);

/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/

   fprintf(cgiOut, "<form action=\"verifyzengin.cgi\" method=\"post\" ");
   fprintf(cgiOut, "enctype=\"multipart/form-data\">");
   fprintf(cgiOut, "<table>");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<th colspan=4 align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "1. Generate the Zengin Header Record (120 Bytes)");
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</th>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "1</th>");
   fprintf(cgiOut, "<td align=\"left\" width=\"100\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Record ID</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"hdr_f1\" value=1>");
   fprintf(cgiOut, "1</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "indicates this is a Header Record</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "2</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Record Type</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"hdr_f2\">");
   fprintf(cgiOut, "<option value=\"21\" selected>21 (JPY Payment)");
   fprintf(cgiOut, "<option value=\"98\">98 (FC Payment)");
   fprintf(cgiOut, "</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Transaction Type (21, 98)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "3</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Code Type</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"hdr_f3\" value=0>");
   fprintf(cgiOut, "0</td>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Character Encoding, 0=JIS, 1=EBCDIC</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "4</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Requestor ID</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f4\" size=12 value=\"1210015866\">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "10 digits Debit Account Number with leading 0, or as assigned by Bank</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "5</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Account Holder Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f5\" size=40 value=\"Test\">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "40 Chars Customer Name in single-byte Katakana</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "6</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Payment Value Date</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f6\" size=4 value=\"%s\">", valuedatestr);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Payment Value Date (current year's MMDD)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "7</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Remitting Bank Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f7\" size=4 value=0401>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "4-digit Zengin Code of the Bank (0401=Citibank)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "8</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Remitting Bank Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f8\" size=15 value=Citibank>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Remitting Bank Name English or single-byte Katakana (i.e. Citibank)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "9</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Remitting Branch Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f9\" size=3 value=730>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "3-digit Zengin Bank Branch Code (Citibank: 730=Tokyo Branch)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "10</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Remitting Branch Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" align=\"left\" name=\"hdr_f10\" size=15 value=Tokyo>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Bank Branch Name English or single-byte Katakana (i.e. Tokyo), left aligned followed by space</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "11</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Account Type Requester</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"hdr_f11\">");
   fprintf(cgiOut, "<option value=\" \">\" \" (unknown space)");
   fprintf(cgiOut, "<option value=\"1\" selected>1 (Ordinary)</option>");
   fprintf(cgiOut, "<option value=\"2\">2 (Check)");
   fprintf(cgiOut, "<option value=\"9\">9 (unknown 9)");
   fprintf(cgiOut, "</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Allows only 1, 2, 9 and " " (Space)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "12</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Requester Account Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"hdr_f12\" size=10 value=\"5158472\">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "First 7 digits of the Sender's Account</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "13</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>FC Payment Currency</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"hdr_f13\">");
   fprintf(cgiOut, "<option value=\"JPY\" selected>JPY</option>");
   fprintf(cgiOut, "<option value=\"USD\">USD");
   fprintf(cgiOut, "<option value=\"EUR\">EUR");
   fprintf(cgiOut, "<option value=\"AUD\">AUD");
   fprintf(cgiOut, "<option value=\"NZD\">NZD");
   fprintf(cgiOut, "</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "3-digit ISO currency code for FC payments, JPY will generate 3 spaces</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "14</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Dummy Field</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"hdr_f14\" value=\"                 \">");
   fprintf(cgiOut, "&nbsp;</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Add 14 spaces to reach 120 Bytes</td>");
   fprintf(cgiOut, "</tr>");


   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<th colspan=4 align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "2. Generate a Zengin Data Record (120 Bytes)");
   fprintf(cgiOut, "</th>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "1</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Record ID</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"data_f1\" value=2>");
   fprintf(cgiOut, "2</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "indicates this is a Data Record</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "2</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Receiving Bank Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f2\" size=4 value=1234>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "4-digit Zengin Code of the Beneficiary Bank</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "3</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Receiving Bank Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f3\" size=19 value=\"Tokyo Mitsubishi\">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Name of the Beneficiary Bank (15-chars)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "4</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Receiving Branch Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f4\" size=3 value=524>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "3-digit Zengin Code of the Beneficiary Bank Branch</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "5</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Receiving Branch Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f5\" size=15 value=Osaka>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Name of the Beneficiary Bank Branch, i.e. Osaka</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "6</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Clearinghouse Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f6\" size=4 value=1234>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "4-digit Zengin Code of the Clearinghouse</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "7</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Account Type</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"data_f7\">");
   fprintf(cgiOut, "<option value=\"1\" selected>1 (Ordinary)</option>");
   fprintf(cgiOut, "<option value=\"2\">2 (Check)");
   fprintf(cgiOut, "<option value=\"4\">4 (unknown 4)");
   fprintf(cgiOut, "<option value=\"9\">9 (unknown 9)");
   fprintf(cgiOut, "</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Beneficiary Account Type (1,2,4,9)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "8</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Account Number</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f8\" size=10 value=0123456>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "7-digit Beneficiary Account number, leading zero</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "9</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Account Owner Name</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f9\" size=30 value=>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Left-aligned single-byte Katakana Name, space fills blanks</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "10</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Yen Payment Amount</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f10\" size=12 value=0000000001>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "10 digits aligned right with leading zeros</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "11</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>New / Amend</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f11\" size=1 value=\" \">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "New Value or Correction</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "12</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Customer Reference 1</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f12\" size=10 value=>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "10-char Customer Reference Field 1</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "13</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Customer Reference 2</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f13\" size=10 value=>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "10-char Customer Reference Field 2 (EDI Info)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "14</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Transfer Priority</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"data_f14\">");
   fprintf(cgiOut, "<option value=\" \">\" \" (unknown space)");
   fprintf(cgiOut, "<option value=\"7\">7 (Express)</option>");
   fprintf(cgiOut, "<option value=\"8\"selected>8 (Normal)");
   fprintf(cgiOut, "</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Type of Payment, 7, 8 or space</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "15</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Identification Display</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"data_f15\" size=1 value=\" \">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Vaild choices \"Y\" and \" \" space</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "16</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Dummy Field</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"data_f16\" value=\"       \">");
   fprintf(cgiOut, "&nbsp;</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Add 7 spaces to reach 120 Bytes</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<th colspan=4 align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "3. Generate the Zengin Trailer-Record (120 Bytes)");
   fprintf(cgiOut, "</th>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "1</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Record ID</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"tlr_f1\" size=1 value=8>");
   fprintf(cgiOut, "8</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "indicates the Trailer Record</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "2</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Total Count</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"tlr_f2\" value=000001>");
   fprintf(cgiOut, "000001</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "6-digit Number of Data Records in this File</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "3</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Total Yen Amount</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"text\" name=\"tlr_f3\" size=15>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "12 digits Total Amount of Payments (Sum)</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<th align=\"left\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "4</th>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#CFCFCF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000000\">");
   fprintf(cgiOut, "<b>Dummy Field</b></td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=\"hidden\" name=\"tlr_f4\" size=10 value=>");
   fprintf(cgiOut, "&nbsp;</td>");
   fprintf(cgiOut, "<td align=\"left\" bgcolor=\"#AFAFAF\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#000080\">");
   fprintf(cgiOut, "Add 101 spaces to reach 120 Bytes</td>");
   fprintf(cgiOut, "</tr>");

   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<th colspan=4 align=\"center\">");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "The End Record (120 Bytes) is auto-generated. ");
   fprintf(cgiOut, "Add CRLF Record Termination: <input type=checkbox name=\"crlf\">");
   fprintf(cgiOut, " <input type=\"submit\" value=\"Generate Content\">");
   fprintf(cgiOut, "</font></th>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "</table>\n");
   fprintf(cgiOut, "</form></center>");

/* -------------------------------------------------------------------------- *
 * end the html output                                                        *
 * ---------------------------------------------------------------------------*/

   pagefoot();
   return(0);
}
