/* -------------------------------------------------------------------------- *
 * file:	decodezengin.c                                                *
 * purpose:	read a zengin file and display its content                    *
 * called as:   decodezengin.cgi?ufilename=citi-zengin-testfile1              *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <cgic.h>
#include "zengingen.h"

int cgiMain() {

  int 		i          = 0;
  int 		j          = 0;

  char		ufilename[81]  = "";
  cgiFilePtr    uploadfile;
  int           size           = 0;
  char          buf;
  static char   title[]        = "Decode a Zengin File";

  /* Check if we got a file uploaded */
  if (cgiFormFileName("ufilename", ufilename, sizeof(ufilename)) == cgiFormSuccess) {
    if (cgiFormFileSize("ufilename", &size) != cgiFormSuccess)
      int_error("Error getting file size of the uploaded file"); 
    if(size > 2048) int_error("Error file to big! Max. file size is 2048 bytes");
    if (cgiFormFileOpen("ufilename", &uploadfile) != cgiFormSuccess) 
      int_error("Could not open the uploaded file.");
    while (cgiFormFileRead(uploadfile, &buf, 1, &j) == cgiFormSuccess){
     zengin_filestr[i] = buf;
     i++;
    }
    cgiFormFileClose(uploadfile);

/* -------------------------------------------------------------------------- *
 * read the zengin file content                                               *
 * ---------------------------------------------------------------------------*/
    zengin_read(zengin_filestr);
    b64_encode(zengin_filestr, zengin_b64str);
/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/
    pagehead(title);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
    write_rawtable(0);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
    fprintf(cgiOut, "<p>");
    fprintf(cgiOut, "<table>");
    fprintf(cgiOut, "<tr>\n");
    fprintf(cgiOut, "<form action=\"editzengin.cgi\" method=\"post\" ");
    fprintf(cgiOut, "enctype=\"multipart/form-data\">");
    fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
    fprintf(cgiOut, "<th>");
    fprintf(cgiOut, "<input type=\"submit\" value=\"Edit Raw Content\">");
    fprintf(cgiOut, "</th>");
    fprintf(cgiOut, "</form>\n");
    fprintf(cgiOut, "<form action=\"buildzengin.cgi\" method=\"post\" ");
    fprintf(cgiOut, "enctype=\"multipart/form-data\">");
    fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
    fprintf(cgiOut, "<th>");
    fprintf(cgiOut, "<input type=\"submit\" value=\"Use as Template\">");
    fprintf(cgiOut, "</th>");
    fprintf(cgiOut, "</form>\n");
    fprintf(cgiOut, "<form action=\"writezengin.cgi\" method=\"post\" ");
    fprintf(cgiOut, "enctype=\"multipart/form-data\">");
    fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
    fprintf(cgiOut, "<th>");
    fprintf(cgiOut, "<input type=\"submit\" value=\"Save To Server\">");
    fprintf(cgiOut, "</th>");
    fprintf(cgiOut, "</form>\n");
    fprintf(cgiOut, "</tr></table>\n");

  } else {
/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/
    pagehead(title);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
    fprintf(cgiOut, "<h3>Introduction</h3>\n");
    fprintf(cgiOut, "<hr>\n");
    fprintf(cgiOut, "<p>\n");
    fprintf(cgiOut, "This function allows to select a local Zengin file stored on your PC. By selcting it and clicking on \"Display Content\", it's formatting will be verified, the files records are parsed and then displayed in your browser. This helps to identify formatting errors in Zengin files. It is quite common that instead of halfbyte, multibyte characters are inserted by accident that break the strict byte-aligned field order in Zengin records.");
    fprintf(cgiOut, "</p>\n");
    fprintf(cgiOut, "<p>\n");
    fprintf(cgiOut, "When the data is displayed, it is then possible to store the file into ZenginGen for future use or reference using the \"Save To Server\" button. <b>Be extremly careful not to save any PRD data here, as PPI information becomes visible to others</b>.");
    fprintf(cgiOut, "</p>\n");
    fprintf(cgiOut, "<form action=\"decodezengin.cgi\" method=\"post\" ");
    fprintf(cgiOut, "enctype=\"multipart/form-data\">");
    fprintf(cgiOut, "<table>");
    fprintf(cgiOut, "<tr>\n");
    fprintf(cgiOut, "<th>");
    fprintf(cgiOut, "Please select your local Zengin file in the ");
    fprintf(cgiOut, "field below:");
    fprintf(cgiOut, "</th>");
    fprintf(cgiOut, "</tr>");
    fprintf(cgiOut, "<tr>");
    fprintf(cgiOut, "<td bgcolor=\"#AFAFAF\" align=\"center\">");
    fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
    fprintf(cgiOut, "<input type=\"file\" name=\"ufilename\" size=\"40\">");
    fprintf(cgiOut, "</font>");
    fprintf(cgiOut, "</td>");
    fprintf(cgiOut, "</tr>");
    fprintf(cgiOut, "<tr>\n");
    fprintf(cgiOut, "<th>");
    fprintf(cgiOut, "<input type=\"submit\" value=\"Display Content\">");
    fprintf(cgiOut, "</th>");
    fprintf(cgiOut, "</tr>");
    fprintf(cgiOut, "</table>\n");
    fprintf(cgiOut, "</form></center>");
  }

  pagefoot();
  return(0);
}
