/* -------------------------------------------------------------------------- *
 * file:	editzengin.c                                                  *
 * purpose:	read a zengin file and edit its content                       *
 * called as:   editzengin.cgi?zfilename=zengin-testfile1                     *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <cgic.h>
#include "zengingen.h"

int cgiMain() {
  int i = 0;

  if (cgiFormString("zfilename", zfilename, sizeof(zfilename)) == cgiFormSuccess)
    snprintf(title, sizeof(title), "%s %s", "Edit Zengin File", zfilename);
  else
    snprintf(title, sizeof(title), "%s", "Edit New Zengin File");

/* -------------------------------------------------------------------------- *
 * Since we gonna display the file, we must make sure no "../../.." is passed *
 * from the calling URL or else sensitive files could be read and we have a   *
 * huge security problem. We scan and must reject all occurrences of '..' '/' *
 * ---------------------------------------------------------------------------*/
  if ( strstr(zfilename, "..") || strchr(zfilename, '/')  ||
       (! strstr(zfilename, "zengin")) )
    int_error("Error incorrect data in >zfilename<");

/* -------------------------------------------------------------------------- *
 * Try to open the requested filename and read it into the string buffer      *
 * ---------------------------------------------------------------------------*/
  snprintf(zfilepath, sizeof(zfilepath), "%s/%s", ZENGINSTORE, zfilename);
  if (! (zenginfile = fopen(zfilepath, "r")))
    int_error("Error cant open zengin file");

  for(i=0;i<sizeof(zengin_filestr);i++) zengin_filestr[i] = getc(zenginfile);
 
  fclose(zenginfile);
/* -------------------------------------------------------------------------- *
 * read the zengin file content                                               *
 * ---------------------------------------------------------------------------*/
  zengin_read(zengin_filestr);
  b64_encode(zengin_filestr, zengin_b64str);
/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/
   pagehead(title);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
  fprintf(cgiOut, "<p><center>");
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
  fprintf(cgiOut, "<form action=\"writezengin.cgi\" method=\"post\" ");
  fprintf(cgiOut, "enctype=\"multipart/form-data\">");
  fprintf(cgiOut, "<div class=\"edit\">\n");
  write_rawtable(1);
  fprintf(cgiOut, "</div>\n");
  if(strlen(zfilename) > 0) fprintf(cgiOut, "<input type=\"hidden\" name=\"zfilename\" value=%s>", zfilename);
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zengin_fmt\" value=%d>", zengin_fmt);

  fprintf(cgiOut, "<p>");
  fprintf(cgiOut, "<table>");
  fprintf(cgiOut, "<th align=\"center\">");
  fprintf(cgiOut, "<input type=\"submit\" value=\"Save Changes\">");
  fprintf(cgiOut, "</th>");
  fprintf(cgiOut, "</form>\n");
  fprintf(cgiOut, "<tr>\n");

  fprintf(cgiOut, "<form action=\"showzengin.cgi\" method=\"post\">");
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
  if(strlen(zfilename) > 0) fprintf(cgiOut, "<input type=\"hidden\" name=\"zfilename\" value=%s>", zfilename);
  fprintf(cgiOut, "<th align=\"center\">");
  fprintf(cgiOut, "<input type=\"submit\" value=\"Cancel Changes\">");
  fprintf(cgiOut, "</th>");
  fprintf(cgiOut, "</form>\n");

  fprintf(cgiOut, "</tr></table>\n");

  pagefoot();
  return(0);
}
