/* -------------------------------------------------------------------------- *
 * file:         pagehead.c                                                   *
 * purpose:      provides a standard page header across all cgi's             *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <cgic.h>
#include "zengingen.h"

void pagehead(char* title) {

   static char homelink[] = HOMELINK;
 
/* -------------------------------------------------------------------------- *
 * start the head output                                                      *
 * ---------------------------------------------------------------------------*/

   cgiHeaderContentType("text/html; charset=shift-jis");
   fprintf(cgiOut, "<html>\n");
   fprintf(cgiOut, "<head>\n");

   fprintf(cgiOut, "<link rel=\"stylesheet\" type=\"text/css\" href=\"../style/style.css\" media=\"screen\" />\n");
   fprintf(cgiOut, "<meta name=\"Title\" content=\"WebCert - %s\" />\n", title);
   fprintf(cgiOut, "<meta name=\"Description\" content=\"WebCert Digital Certificate Management\" />\n");
   fprintf(cgiOut, "<meta name=\"Keywords\" content=\"SSL, HTTPS, TLS, certificate, x509\" />\n");
   fprintf(cgiOut, "<title>>ZenginGen - %s</title>\n", title);
   fprintf(cgiOut, "</head>\n");

   fprintf(cgiOut, "<body>\n");
   fprintf(cgiOut, "<div id=\"wrapper\">\n");
   fprintf(cgiOut, "<div id=\"banner\">\n");
   fprintf(cgiOut, "<h1>ZenginGen - %s</h1>\n", title);
   fprintf(cgiOut, "<h2>Web-based Zengin File Management</h2>\n");
   fprintf(cgiOut, "</div>\n");

   fprintf(cgiOut, "<div id=\"vmenu\">\n");
   fprintf(cgiOut, "<ul>\n");
   fprintf(cgiOut, "<li><a href=\"%s\" class=\"selected\"><span>Home</span></a></li>\n", homelink);
   fprintf(cgiOut, "<li><a href=\"buildzengin.cgi\"><span>Build a Zengin File</span></a></li>\n");
   fprintf(cgiOut, "<li><a href=\"zenginstore.cgi\"><span>Show All Zengin Files</span></a></li>\n");
   fprintf(cgiOut, "<li><a href=\"decodezengin.cgi\">Decode a Zengin File</span></a></li>\n");
   fprintf(cgiOut, "<li><a href=\"help.cgi\"><span>Help</span></a></li>\n");
   fprintf(cgiOut, "</ul>\n");
   fprintf(cgiOut, "</div>\n");

   fprintf(cgiOut, "<div id=\"content\">\n");
}
