/* -------------------------------------------------------------------------- *
 * file:	showzengin.c                                                  *
 * purpose:	read a zengin file and display its content                    *
 * called as:   showzengin.cgi?zfilename=citi-zengin-testfile1                *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <cgic.h>
#include "zengingen.h"

int cgiMain() {
  int i = 0;

  if (cgiFormString("zfilename", zfilename, sizeof(zfilename)) != cgiFormSuccess)
    int_error("Error expecting zfilename form string with file to dsiplay.");

  snprintf(title, sizeof(title), "%s %s", "Showing Zengin File", zfilename);

/* -------------------------------------------------------------------------- *
 * Since we gonna display the file, we must make sure no "../../.." is passed *
 * from the calling URL or else sensitive files could be read and we have a   *
 * huge security problem. We scan and must reject all occurrences of '..' '/' *
 * ---------------------------------------------------------------------------*/
  if ( strstr(zfilename, "..") || strchr(zfilename, '/')  ||
       (! strstr(zfilename, "zengin")) )
    int_error("Error incorrect data in >zfilename<");

/* -------------------------------------------------------------------------- *
 * Try to open the requested filename and read it into the string buffer      *
 * ---------------------------------------------------------------------------*/
  snprintf(zfilepath, sizeof(zfilepath), "%s/%s", ZENGINSTORE, zfilename);
  if (! (zenginfile = fopen(zfilepath, "r")))
    int_error("Error cant open zengin file");

  for(i=0;i<sizeof(zengin_filestr);i++) zengin_filestr[i] = getc(zenginfile);
 
  fclose(zenginfile);
/* -------------------------------------------------------------------------- *
 * read the zengin file content                                               *
 * ---------------------------------------------------------------------------*/
  zengin_read(zengin_filestr);
  b64_encode(zengin_filestr, zengin_b64str);
/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/
   pagehead(title);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
  write_rawtable(0);
/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/
  fprintf(cgiOut, "<p>");
  fprintf(cgiOut, "<table>");
  fprintf(cgiOut, "<tr>\n");
  fprintf(cgiOut, "<form action=\"editzengin.cgi\" method=\"post\" ");
  fprintf(cgiOut, "enctype=\"multipart/form-data\">");
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zfilename\" value=%s>", zfilename);
  fprintf(cgiOut, "<th>");
  fprintf(cgiOut, "<input type=\"submit\" value=\"Edit Raw Content\">");
  fprintf(cgiOut, "</th>");
  fprintf(cgiOut, "</form>\n");
  fprintf(cgiOut, "<form action=\"buildzengin.cgi\" method=\"post\" ");
  fprintf(cgiOut, "enctype=\"multipart/form-data\">");
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zfilename\" value=%s>", zfilename);
  fprintf(cgiOut, "<th>");
  fprintf(cgiOut, "<input type=\"submit\" value=\"Edit Record Fields\">");
  fprintf(cgiOut, "</th>");
  fprintf(cgiOut, "</form>\n");
  fprintf(cgiOut, "<form action=\"buildzengin.cgi\" method=\"post\" ");
  fprintf(cgiOut, "enctype=\"multipart/form-data\">");
  fprintf(cgiOut, "<input type=\"hidden\" name=\"zengindata\" value=%s>", zengin_b64str);
  fprintf(cgiOut, "<th>");
  fprintf(cgiOut, "<input type=\"submit\" value=\"Use as Template\">");
  fprintf(cgiOut, "</th>");
  fprintf(cgiOut, "</form>\n");
  fprintf(cgiOut, "</tr></table>\n");

  pagefoot();
  return(0);
}
