/* ---------------------------------------------------------------------------*
 * file:        zengingen.h                                                     *
 * purpose:     provide standard definitions accross cgi's                    *
 * author:      06/29/2009 Frank4DD                                           *
 * ---------------------------------------------------------------------------*/

/*********** the main URL where the zengingen application resides ***************/
#define HOMELINK	"/sw/zengingen/"
/*********** the application entry URL which is seen first ********************/
#define CSSLINK		"/sw/zengingen/style/style.css"
/*********** the application entry URL which is seen first ********************/
#define REQLINK		"/sw/zengingen/cgi-bin/certrequest.cgi"
/*********** The directory where the generated zenging files are stored ********/
#define ZENGINSTORE     "/srv/www/std-root/fm4dd.com/sw/zengingen/store"

#define MAXFILEDISPLAY  15    /* # of files that will be shown in one webpage */

/*********** html code template for populating the sidebar  *******************/
#define SIDEBAR_TEMPL   "../sidebar-template.htm" /* optional */
/*********** html code template for populating the help data  *****************/
#define HELP_TEMPL      "../help-template.htm" /* mandatory */
/****** html code template for adding code or scripts into the footer *********/
#define FOOTER_TEMPL    "../footer-template.htm" /* optional */

/***************** no changes required below this line ************************/

#define CONTACT_EMAIL	"support@frank4dd.com"
#define SW_VERSION	"ZenginGen v1.1.0 (07/12/2011)"

#define RECLEN		120 	/* Max length of a Zengin Record in bytes. */

#define MAXDATA		20      /* Max set of data records per Zengin file */
				/* limited by the 6-digit field of the     */
				/* trailer record = 99999                  */
#define MAXBYTELEN     3*RECLEN+MAXDATA*RECLEN+3*2+MAXDATA*2+1
#define MAXB64LEN      (MAXBYTELEN/3)*4

//char zengin_filestr[3*RECLEN+MAXDATA*RECLEN+3*2+MAXDATA*2+1];
char zengin_filestr[MAXBYTELEN];
char zengin_filebuf[MAXBYTELEN];
char zengin_b64str[MAXB64LEN];

#define int_error(msg)  handle_error(__FILE__, __LINE__, msg)
void handle_error(const char *file, int lineno, const char *msg);
void pagehead(char *title);
void pagefoot();

#define HDR_FIELDS	14
#define DATA_FIELDS	16
#define TRAILER_FIELDS	4
#define END_FIELDS      2

#define CRLF_FMT	1
#define NO_CRLF_FMT	2
#define LF_FMT          3
int zengin_fmt;
int data_records;
int total_amount;
char valuedate[5];
char currency[4];
char zfilepath[255];
char zfilename[81];
FILE *zenginfile;
char errorstr[1024];
char title[1024];

char hdr[HDR_FIELDS][41];
char data[DATA_FIELDS][31];
char tlr[TRAILER_FIELDS][102];

struct z1 {
  char hdr_record[121];
  char data_records[MAXDATA][121];
  char tlr_record[121];
  char end_record[121];
} zengin_records;

void zengin_read(char * zenginbuf);
void get_valuedate();
void get_currency();
void get_total();
void add_crlf();
void write_rawtable(int mode);
void b64_encode( char *instr, char *outstr);
void b64_decode( char *instr, char *outstr);

/****************************** end zengingen.h *********************************/
